// need to add conditional instructions
// need to add special registers
char *registers[] =
{
	"_al\2",
	"_ah\2",
	"_ax\2",

	"_bl\2",
	"_bh\2",
	"_bx\2",

	"_cl\2",
	"_ch\2",
	"_cr0\2",
	"_cr1\2",
	"_cr2\2",
	"_cr3\2",
	"_cr4\2",
	"_cs\2",
	"_cx\2",

	"_dl\2",
	"_dh\2",
	"_di\2",
	"_ds\2",
	"_dx\2",

	"_eax\2",
	"_ebx\2",
	"_ecx\2",
	"_edi\2",
	"_edx\2",
	"_es\2",
	"_esi\2",

	"_fs\2",

	"_gs\2",

	"_mm0\2",
	"_mm1\2",
	"_mm2\2",
	"_mm3\2",
	"_mm4\2",
	"_mm5\2",
	"_mm6\2",
	"_mm7\2",

	"_si\2",
	"_ss\2"
};

char *opcodes[] =
{
	"_aaa\1",
	"_aad\1",
	"_aam\1",
	"_aas\1",
	"_adc\1",
	"_add\1",
	"_addps\1",
	"_addss\1",
	"_and\1",
	"_andnps\1",
	"_andps\1",
	"_arpl\1",

	"_bound\1",
	"_bsf\1",
	"_bsr\1",
	"_bswap\1",
	"_bt\1",
	"_btc\1",
	"_btr\1",
	"_bts\1",

	"_call\1",
	"_cbw\1",
	"_cdq\1",
	"_clc\1",
	"_cld\1",
	"_cli\1",
	"_clts\1",
	"_cmc\1",
	"_cmp\1",
	"_cmpeqps\1",
	"_cmpeqss\1",
	"_cmpleps\1",
	"_cmpless\1",
	"_cmpltps\1",
	"_cmpltss\1",
	"_cmpneqps\1",
	"_cmpneqss\1",
	"_cmpnleps\1",
	"_cmpnless\1",
	"_cmpnltps\1",
	"_cmpnltss\1",
	"_cmpordps\1",
	"_cmpordss\1",
	"_cmpps\1",
	"_cmpsb\1",
	"_cmpsd\1",
	"_cmpss\1",
	"_cmpsw\1",
	"_cmpunordps\1",
	"_cmpunordss\1",
	"_cmpxchg\1",
	"_cmpxchg486\1",
	"_cmpxchg8b\1",
	"_comiss\1",
	"_cpuid\1",
	"_cvtpi2ps\1",
	"_cvtps2pi\1",
	"_cvtsi2ss\1",
	"_cvtss2si\1",
	"_cvttps2pi\1",
	"_cvttss2si\1",
	"_cwd\1",
	"_cwde\1",

	"_daa\1",
	"_das\1",
	"_db\1",
	"_dd\1",
	"_dec\1",
	"_div\1",
	"_divps\1",
	"_divss\1",
	"_dq\1",
	"_dt\1",
	"_dw\1",

	"_emms\1",
	"_enter\1",
	"_equ\1",

	"_f2xm1\1",
	"_fabs\1",
	"_fadd\1",
	"_faddp\1",
	"_fbld\1",
	"_fbstp\1",
	"_fchs\1",
	"_fclex\1",
	"_fcmovb\1",
	"_fcmovbe\1",
	"_fcmove\1",
	"_fcmovnb\1",
	"_fcmovnbe\1",
	"_fcmovne\1",
	"_fcmovnu\1",
	"_fcmovu\1",
	"_fcom\1",
	"_fcomi\1",
	"_fcomip\1",
	"_fcomp\1",
	"_fcompp\1",
	"_fcos\1",
	"_fdecstp\1",
	"_fdisi\1",
	"_fdiv\1",
	"_fdivp\1",
	"_fdivr\1",
	"_fdivrp\1",
	"_femms\1",
	"_feni\1",
	"_ffree\1",
	"_fiadd\1",
	"_ficom\1",
	"_ficomp\1",
	"_fidiv\1",
	"_fidivr\1",
	"_fild\1",
	"_fimul\1",
	"_fincstp\1",
	"_finit\1",
	"_fist\1",
	"_fistp\1",
	"_fisub\1",
	"_fisubr\1",
	"_fld\1",
	"_fld1\1",
	"_fldcw\1",
	"_fldenv\1",
	"_fldl2e\1",
	"_fldl2t\1",
	"_fldlg2\1",
	"_fldln2\1",
	"_fldpi\1",
	"_fldz\1",
	"_fmul\1",
	"_fmulp\1",
	"_fnclex\1",
	"_fndisi\1",
	"_fneni\1",
	"_fninit\1",
	"_fnop\1",
	"_fnsave\1",
	"_fnstcw\1",
	"_fnstenv\1",
	"_fnstsw\1",
	"_fpatan\1",
	"_fprem\1",
	"_fprem1\1",
	"_fptan\1",
	"_frndint\1",
	"_frstor\1",
	"_fsave\1",
	"_fscale\1",
	"_fsetpm\1",
	"_fsin\1",
	"_fsincos\1",
	"_fsqrt\1",
	"_fst\1",
	"_fstcw\1",
	"_fstenv\1",
	"_fstp\1",
	"_fstsw\1",
	"_fsub\1",
	"_fsubp\1",
	"_fsubr\1",
	"_fsubrp\1",
	"_ftst\1",
	"_fucom\1",
	"_fucomi\1",
	"_fucomip\1",
	"_fucomp\1",
	"_fucompp\1",
	"_fxam\1",
	"_fxch\1",
	"_fxrstor\1",
	"_fxsave\1",
	"_fxtract\1",
	"_fyl2x\1",
	"_fyl2xp1\1",

	"_hlt\1",

	"_ibts\1",
	"_icebp\1",
	"_idiv\1",
	"_imul\1",
	"_in\1",
	"_inc\1",
	"_incbin\1",
	"_insb\1",
	"_insd\1",
	"_insw\1",
	"_int\1",
	"_int01\1",
	"_int03\1",
	"_int1\1",
	"_int3\1",
	"_into\1",
	"_invd\1",
	"_invlpg\1",
	"_iret\1",
	"_iretd\1",
	"_iretw\1",

	"_jcxz\1",
	"_jecxz\1",
	"_jmp\1",

	"_lahf\1",
	"_lar\1",
	"_ldmxcsr\1",
	"_lds\1",
	"_lea\1",
	"_leave\1",
	"_les\1",
	"_lfs\1",
	"_lgdt\1",
	"_lgs\1",
	"_lidt\1",
	"_lldt\1",
	"_lmsw\1",
	"_loadall\1",
	"_loadall286\1",
	"_lodsb\1",
	"_lodsd\1",
	"_lodsw\1",
	"_loop\1",
	"_loope\1",
	"_loopne\1",
	"_loopnz\1",
	"_loopz\1",
	"_lsl\1",
	"_lss\1",
	"_ltr\1",

	"_maskmovq\1",
	"_maxps\1",
	"_maxss\1",
	"_minps\1",
	"_minss\1",
	"_mov\1",
	"_movaps\1",
	"_movd\1",
	"_movhlps\1",
	"_movhps\1",
	"_movlhps\1",
	"_movlps\1",
	"_movmskps\1",
	"_movntps\1",
	"_movntq\1",
	"_movq\1",
	"_movsb\1",
	"_movsd\1",
	"_movss\1",
	"_movsw\1",
	"_movsx\1",
	"_movups\1",
	"_movzx\1",
	"_mul\1",
	"_mulps\1",
	"_mulss\1",

	"_neg\1",
	"_nop\1",
	"_not\1",

	"_or\1",
	"_orps\1",
	"_out\1",
	"_outsb\1",
	"_outsd\1",
	"_outsw\1",

	"_packssdw\1",
	"_packsswb\1",
	"_packuswb\1",
	"_paddb\1",
	"_paddd\1",
	"_paddsb\1",
	"_paddsiw\1",
	"_paddsw\1",
	"_paddusb\1",
	"_paddusw\1",
	"_paddw\1",
	"_pand\1",
	"_pandn\1",
	"_paveb\1",
	"_pavgb\1",
	"_pavgusb\1",
	"_pavgw\1",
	"_pcmpeqb\1",
	"_pcmpeqd\1",
	"_pcmpeqw\1",
	"_pcmpgtb\1",
	"_pcmpgtd\1",
	"_pcmpgtw\1",
	"_pdistib\1",
	"_pextrw\1",
	"_pf2id\1",
	"_pfacc\1",
	"_pfadd\1",
	"_pfcmpeq\1",
	"_pfcmpge\1",
	"_pfcmpgt\1",
	"_pfmax\1",
	"_pfmin\1",
	"_pfmul\1",
	"_pfrcp\1",
	"_pfrcpit1\1",
	"_pfrcpit2\1",
	"_pfrsqit1\1",
	"_pfrsqrt\1",
	"_pfsub\1",
	"_pfsubr\1",
	"_pi2fd\1",
	"_pinsrw\1",
	"_pmachriw\1",
	"_pmaddwd\1",
	"_pmagw\1",
	"_pmaxsw\1",
	"_pmaxub\1",
	"_pminsw\1",
	"_pminub\1",
	"_pmovmskb\1",
	"_pmulhriw\1",
	"_pmulhrwa\1",
	"_pmulhrwc\1",
	"_pmulhuw\1",
	"_pmulhw\1",
	"_pmullw\1",
	"_pmvgezb\1",
	"_pmvlzb\1",
	"_pmvnzb\1",
	"_pmvzb\1",
	"_pop\1",
	"_popa\1",
	"_popad\1",
	"_popaw\1",
	"_popf\1",
	"_popfd\1",
	"_popfw\1",
	"_por\1",
	"_prefetch\1",
	"_prefetchnta\1",
	"_prefetcht0\1",
	"_prefetcht1\1",
	"_prefetcht2\1",
	"_prefetchw\1",
	"_psadbw\1",
	"_pshufw\1",
	"_pslld\1",
	"_psllq\1",
	"_psllw\1",
	"_psrad\1",
	"_psraw\1",
	"_psrld\1",
	"_psrlq\1",
	"_psrlw\1",
	"_psubb\1",
	"_psubd\1",
	"_psubsb\1",
	"_psubsiw\1",
	"_psubsw\1",
	"_psubusb\1",
	"_psubusw\1",
	"_psubw\1",
	"_punpckhbw\1",
	"_punpckhdq\1",
	"_punpckhwd\1",
	"_punpcklbw\1",
	"_punpckldq\1",
	"_punpcklwd\1",
	"_push\1",
	"_pusha\1",
	"_pushad\1",
	"_pushaw\1",
	"_pushf\1",
	"_pushfd\1",
	"_pushfw\1",
	"_pxor\1",

	"_rcl\1",
	"_rcpps\1",
	"_rcpss\1",
	"_rcr\1",
	"_rdmsr\1",
	"_rdpmc\1",
	"_rdshr\1",
	"_rdtsc\1",
	"_resb\1",
	"_resd\1",
	"_resq\1",
	"_rest\1",
	"_resw\1",
	"_ret\1",
	"_retf\1",
	"_retn\1",
	"_rol\1",
	"_ror\1",
	"_rsdc\1",
	"_rsldt\1",
	"_rsm\1",
	"_rsqrtps\1",
	"_rsqrtss\1",

	"_sahf\1",
	"_sal\1",
	"_salc\1",
	"_sar\1",
	"_sbb\1",
	"_scasb\1",
	"_scasd\1",
	"_scasw\1",
	"_sfence\1",
	"_sgdt\1",
	"_shl\1",
	"_shld\1",
	"_shr\1",
	"_shrd\1",
	"_shufps\1",
	"_sidt\1",
	"_sldt\1",
	"_smi\1",
	"_smint\1",
	"_smintold\1",
	"_smsw\1",
	"_sqrtps\1",
	"_sqrtss\1",
	"_stc\1",
	"_std\1",
	"_sti\1",
	"_stmxcsr\1",
	"_stosb\1",
	"_stosd\1",
	"_stosw\1",
	"_str\1",
	"_sub\1",
	"_subps\1",
	"_subss\1",
	"_svdc\1",
	"_svldt\1",
	"_svts\1",
	"_syscall\1",
	"_sysenter\1",
	"_sysexit\1",
	"_sysret\1",

	"_test\1",

	"_ucomiss\1",
	"_ud1\1",
	"_ud2\1",
	"_umov\1",
	"_unpckhps\1",
	"_unpcklps\1",

	"_verr\1",
	"_verw\1",

	"_wait\1",
	"_wbinvd\1",
	"_wrmsr\1",
	"_wrshr\1",

	"_xadd\1",
	"_xbts\1",
	"_xchg\1",
	"_xlatb\1",
	"_xor\1",
	"_xorps\1"
};
